package com.lantone.structure.facade.tran;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.lantone.common.util.FastJsonUtils;
import com.lantone.structure.model.doc.ClinicalBloodDoc;
import com.lantone.structure.util.MapUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2021/2/2 14:16
 */
@Slf4j
public class ClinicalBloodTran extends TargetTran {

    @Override
    public Map<String, String> convert(String text) {
        List<ClinicalBloodDoc> clinicalBloodDocList = new ArrayList<>();
        ClinicalBloodDoc clinicalBloodDoc = new ClinicalBloodDoc();
        clinicalBloodDoc.setText(text);
        clinicalBloodDocList.add(clinicalBloodDoc);
        inputInfo.setClinicalBloodDocs(clinicalBloodDocList);
        return null;
    }

    public void bloodKeyContrastCommon(Map sourceMap, Map<String, String> keyContrastMap, Map<String, String> retMap) {
        Map<String, Object> sourceMap_ = MapUtil.copyMap(sourceMap);
        for (Map.Entry<String, Object> dateEntry : sourceMap_.entrySet()) {
            try {
                Object object = JSON.parse(FastJsonUtils.getBeanToJson(dateEntry.getValue()));
                if (object instanceof JSONObject) {
                    Map<String, Object> firstJsonMap = FastJsonUtils.getJsonToMap(FastJsonUtils.getBeanToJson(dateEntry.getValue()));
                    if (firstJsonMap.size() == 1) {
                        String key = keyContrastMap.get(dateEntry.getKey());
                        retMap.put(key, (String) firstJsonMap.get("name"));
                    } else {
                        StringBuffer sbX = new StringBuffer();
                        for (Map.Entry<String, Object> firstDateEntry : firstJsonMap.entrySet()) {
                            String beanToJson = FastJsonUtils.getBeanToJson(firstDateEntry.getValue());
                            if (beanToJson.contains("name") || beanToJson.contains("measurementUnit")) {
                                Map<String, Object> jsonToMap = FastJsonUtils.getJsonToMap(FastJsonUtils.getBeanToJson(firstDateEntry.getValue()));
                                if (jsonToMap.size() == 1) {
                                    String childKey = keyContrastMap.get(firstDateEntry.getKey());
                                    if (retMap.containsKey(keyContrastMap.get(firstDateEntry.getKey()))) {
                                        retMap.put(keyContrastMap.get(dateEntry.getKey()) + childKey, (String) jsonToMap.get("name"));
                                    } else {
                                        retMap.put(childKey, (String) jsonToMap.get("name"));
                                    }
                                } else {
                                    for (Map.Entry<String, Object> typeObjectEntry : jsonToMap.entrySet()) {
                                        Object value = typeObjectEntry.getValue();
                                        if (value instanceof JSONObject) {
                                            Map<String, Object> objToMap = FastJsonUtils.getJsonToMap(FastJsonUtils.getBeanToJson(value));
                                            sbX.append(objToMap.get("name"));
                                        } else {
                                            sbX.append(jsonToMap.get("name"));
                                        }

                                    }
                                }
                            } else {
                                sbX.append(firstDateEntry.getValue());
                            }
                            retMap.put(keyContrastMap.get(dateEntry.getKey()), sbX.toString());
                        }

                    }
                } else if (object instanceof JSONArray) {
                    List<Map<String, Object>> jsonToListMap = FastJsonUtils.getJsonToListMap(FastJsonUtils.getBeanToJson(dateEntry.getValue()));
                    int count = 1;
                    StringBuffer sb = new StringBuffer();
                    if (jsonToListMap.size() == 1) {
                        Object name = jsonToListMap.get(0).get("name");
                        retMap.put(keyContrastMap.get(dateEntry.getKey()), String.valueOf(name));
                    } else {
                        for (Map<String, Object> mapList : jsonToListMap) {
                            for (Map.Entry<String, Object> stringObjectEntry : mapList.entrySet()) {
                                if (stringObjectEntry.getKey() == "negative") {
                                    Map<String, Object> negativeJsonMap = FastJsonUtils.getJsonToMap(FastJsonUtils.getBeanToJson(stringObjectEntry.getValue()));
                                    Object negativeObject = negativeJsonMap.get("name");
                                    sb.append((count++) + "." + (negativeObject == null ? "" : negativeObject));
                                } else if (stringObjectEntry.getKey() == "name") {
                                    sb.append(stringObjectEntry.getValue());
                                }
                            }
                        }
                        retMap.put(keyContrastMap.get(dateEntry.getKey()), sb.toString());
                    }

                }

            } catch (JSONException e) {
                log.error(keyContrastMap.get(dateEntry.getKey()) + "json为空");
            }
        }
    }

}